/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SalesforceConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SalesforceConnectorFormAllOf{}

// SalesforceConnectorFormAllOf struct for SalesforceConnectorFormAllOf
type SalesforceConnectorFormAllOf struct {
	// Source label
	Label *string `json:"label,omitempty"`
	// OAuth ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Salesforce instance
	Instance *string `json:"instance,omitempty"`
	// Object to be queried
	Object *string `json:"object,omitempty"`
	// Salesforce API version
	ApiVersion *string `json:"apiVersion,omitempty"`
	// Salesforce filter
	Filter *string `json:"filter,omitempty"`
	// List of selected fields
	Attribute []string `json:"attribute,omitempty"`
}

// NewSalesforceConnectorFormAllOf instantiates a new SalesforceConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSalesforceConnectorFormAllOf() *SalesforceConnectorFormAllOf {
	this := SalesforceConnectorFormAllOf{}
	return &this
}

// NewSalesforceConnectorFormAllOfWithDefaults instantiates a new SalesforceConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSalesforceConnectorFormAllOfWithDefaults() *SalesforceConnectorFormAllOf {
	this := SalesforceConnectorFormAllOf{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *SalesforceConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *SalesforceConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *SalesforceConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *SalesforceConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *SalesforceConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *SalesforceConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetInstance returns the Instance field value if set, zero value otherwise.
func (o *SalesforceConnectorFormAllOf) GetInstance() string {
	if o == nil || IsNil(o.Instance) {
		var ret string
		return ret
	}
	return *o.Instance
}

// GetInstanceOk returns a tuple with the Instance field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorFormAllOf) GetInstanceOk() (*string, bool) {
	if o == nil || IsNil(o.Instance) {
		return nil, false
	}
	return o.Instance, true
}

// HasInstance returns a boolean if a field has been set.
func (o *SalesforceConnectorFormAllOf) HasInstance() bool {
	if o != nil && !IsNil(o.Instance) {
		return true
	}

	return false
}

// SetInstance gets a reference to the given string and assigns it to the Instance field.
func (o *SalesforceConnectorFormAllOf) SetInstance(v string) {
	o.Instance = &v
}

// GetObject returns the Object field value if set, zero value otherwise.
func (o *SalesforceConnectorFormAllOf) GetObject() string {
	if o == nil || IsNil(o.Object) {
		var ret string
		return ret
	}
	return *o.Object
}

// GetObjectOk returns a tuple with the Object field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorFormAllOf) GetObjectOk() (*string, bool) {
	if o == nil || IsNil(o.Object) {
		return nil, false
	}
	return o.Object, true
}

// HasObject returns a boolean if a field has been set.
func (o *SalesforceConnectorFormAllOf) HasObject() bool {
	if o != nil && !IsNil(o.Object) {
		return true
	}

	return false
}

// SetObject gets a reference to the given string and assigns it to the Object field.
func (o *SalesforceConnectorFormAllOf) SetObject(v string) {
	o.Object = &v
}

// GetApiVersion returns the ApiVersion field value if set, zero value otherwise.
func (o *SalesforceConnectorFormAllOf) GetApiVersion() string {
	if o == nil || IsNil(o.ApiVersion) {
		var ret string
		return ret
	}
	return *o.ApiVersion
}

// GetApiVersionOk returns a tuple with the ApiVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorFormAllOf) GetApiVersionOk() (*string, bool) {
	if o == nil || IsNil(o.ApiVersion) {
		return nil, false
	}
	return o.ApiVersion, true
}

// HasApiVersion returns a boolean if a field has been set.
func (o *SalesforceConnectorFormAllOf) HasApiVersion() bool {
	if o != nil && !IsNil(o.ApiVersion) {
		return true
	}

	return false
}

// SetApiVersion gets a reference to the given string and assigns it to the ApiVersion field.
func (o *SalesforceConnectorFormAllOf) SetApiVersion(v string) {
	o.ApiVersion = &v
}

// GetFilter returns the Filter field value if set, zero value otherwise.
func (o *SalesforceConnectorFormAllOf) GetFilter() string {
	if o == nil || IsNil(o.Filter) {
		var ret string
		return ret
	}
	return *o.Filter
}

// GetFilterOk returns a tuple with the Filter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorFormAllOf) GetFilterOk() (*string, bool) {
	if o == nil || IsNil(o.Filter) {
		return nil, false
	}
	return o.Filter, true
}

// HasFilter returns a boolean if a field has been set.
func (o *SalesforceConnectorFormAllOf) HasFilter() bool {
	if o != nil && !IsNil(o.Filter) {
		return true
	}

	return false
}

// SetFilter gets a reference to the given string and assigns it to the Filter field.
func (o *SalesforceConnectorFormAllOf) SetFilter(v string) {
	o.Filter = &v
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *SalesforceConnectorFormAllOf) GetAttribute() []string {
	if o == nil || IsNil(o.Attribute) {
		var ret []string
		return ret
	}
	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorFormAllOf) GetAttributeOk() ([]string, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *SalesforceConnectorFormAllOf) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given []string and assigns it to the Attribute field.
func (o *SalesforceConnectorFormAllOf) SetAttribute(v []string) {
	o.Attribute = v
}

func (o SalesforceConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SalesforceConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Instance) {
		toSerialize["instance"] = o.Instance
	}
	if !IsNil(o.Object) {
		toSerialize["object"] = o.Object
	}
	if !IsNil(o.ApiVersion) {
		toSerialize["apiVersion"] = o.ApiVersion
	}
	if !IsNil(o.Filter) {
		toSerialize["filter"] = o.Filter
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	return toSerialize, nil
}

type NullableSalesforceConnectorFormAllOf struct {
	value *SalesforceConnectorFormAllOf
	isSet bool
}

func (v NullableSalesforceConnectorFormAllOf) Get() *SalesforceConnectorFormAllOf {
	return v.value
}

func (v *NullableSalesforceConnectorFormAllOf) Set(val *SalesforceConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableSalesforceConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableSalesforceConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSalesforceConnectorFormAllOf(val *SalesforceConnectorFormAllOf) *NullableSalesforceConnectorFormAllOf {
	return &NullableSalesforceConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableSalesforceConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSalesforceConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
